IMPLEMENTATION MODULE Args;

IMPORT Lib;


PROCEDURE Reset();
BEGIN
  cnt := Lib.ParamCount();
  idx := 1;
  sym := symNull;
  lit[0] := CHR(0);
END Reset;

PROCEDURE Read();
BEGIN
  IF idx > cnt THEN
    lit[0] := CHR(0);
    sym := symEOA;
  ELSE
    Lib.ParamStr( lit, idx );
    INC( idx );
    IF lit[0] IN optChars THEN
      Str.Delete( lit, 0, 1 );
      sym := symOpt;
    ELSE
      sym := symArg;
    END;
  END;
END Read;

BEGIN
  optChars := defOptChars;
  Reset();
END Args.