MODULE PL0;  (*NW WS 83/84*)

IMPORT Args, FIO;
IMPORT PL0SCA, PL0PAR, PL0GEN, PL0INT;

CONST
  err = FIO.ErrorOutput;

PROCEDURE Options();
BEGIN
  WHILE Args.sym = Args.symOpt DO
    Args.Read();
  END;
END Options;

BEGIN
  Args.Read(); Options();
  WHILE Args.sym = Args.symArg DO
    IF FIO.Exists( Args.lit ) THEN
      PL0SCA.src := FIO.OpenRead( Args.lit );
      PL0SCA.Init();
      PL0GEN.Init();
      PL0PAR.Run();
      PL0SCA.Close();
      PL0GEN.End();
      FIO.Close( PL0SCA.src );
      IF PL0PAR.noErr THEN
        PL0INT.Run();
      ELSE
        FIO.WrStr( err, 'Incorrect: "' );
        FIO.WrStr( err, Args.lit );
        FIO.WrStr( err, '".' );
        FIO.WrLn( err );
      END;
    ELSE
      FIO.WrStr( err, 'File not found: "' );
      FIO.WrStr( err, Args.lit );
      FIO.WrStr( err, '".' );
      FIO.WrLn( err );
    END;
    Args.Read(); Options();
  END;
END PL0.
